unit Fmslide;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, FileCtrl, StdCtrls, Buttons, Menus,
  ExtDlgs, JPEG;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Directory1: TMenuItem;
    Button1: TButton;
    Start1: TMenuItem;
    Delays1: TMenuItem;
    N1Second1: TMenuItem;
    N2Seconds1: TMenuItem;
    N3Seconds1: TMenuItem;
    N4Seconds1: TMenuItem;
    Fast1: TMenuItem;
    Stop1: TMenuItem;
    Pause1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Panel2: TPanel;
    Label1: TLabel;
    IMGPanel: TPanel;
    Image1: TImage;
    Panel3: TPanel;
    ScrollBar1: TScrollBar;
    Panel4: TPanel;
    ScrollBar2: TScrollBar;
    SpeedButton1: TSpeedButton;
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Directory1Click(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure N1Second1Click(Sender: TObject);
    procedure N2Seconds1Click(Sender: TObject);
    procedure N3Seconds1Click(Sender: TObject);
    procedure N4Seconds1Click(Sender: TObject);
    procedure Fast1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Stretch1Click(Sender: TObject);
    procedure Panel1Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
    var ScrollPos: Integer);
    procedure Image1Progress(Sender: TObject; Stage: TProgressStage;
    PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
    const Msg: String);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    Units: TPoint;
    FDirty: Boolean;
    procedure SetDirty(d: Boolean);
    procedure ScrollReset;
    procedure ScrollAdjust(update: Boolean);
    procedure UpdateDisplay;
    property Dirty: Boolean read FDirty write SetDirty;
  public
    { Public declarations }
  end;

const DEF_SCROLL_UNITS = 8;
var Form1: TForm1; I : Integer;

implementation

uses Unit2; {$R *.DFM}

procedure TForm1.SetDirty(d: Boolean);
begin
  if d <> FDirty then
  begin
    FDirty := d;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var FileExt: string[4];
begin
  Label1.Caption := 'Current File No# ' + IntToStr(I) + '   ';
  FileExt := AnsiUpperCase(ExtractFileExt(FileListBox1.Filename));
  if (FileExt = '.BMP') or (FileExt = '.ICO') or (FileExt = '.WMF') or
    (FileExt = '.EMF') or (FileExt = '.JPG') then
    if FileListBox1.ItemIndex >= 0 then
    if I = FileListBox1.Items.Count then
     begin
       Timer1.Enabled := False;
       Start1.Enabled := False;
       I := 0;
     end;
     begin
       if FileExt = '.ICO' then Icon := Image1.Picture.Icon;
       if (FileExt = '.WMF') or (FileExt = '.EMF') then
        Image1.Picture.Metafile := Image1.Picture.Metafile;
       Image1.Picture.LoadFromFile(FileListBox1.FileName);
       ScrollReset;
       Panel2.Caption := FileListBox1.FileName + ' Total Files = ' + IntToStr(FileListBox1.Items.Count);
       Caption := ExtractFileName(FileListBox1.FileName);
       FileListBox1.ItemIndex := FileListBox1.ItemIndex + 1;
   end;
  I := I + 1;
end;

function scale(n, u: Integer): Integer;
begin
  Result := (n + u - 1) div u;
end;

function maxval(a, b: Integer): Integer;
begin
  if a >= b then
    Result := a
  else
    Result := b;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Panel1.Visible := False;
  Directory1.Enabled := False;
  Start1.Enabled := True;
end;

procedure TForm1.Directory1Click(Sender: TObject);
begin
  Stop1.Enabled := True;
  Pause1.Enabled := True;
  Panel1.Visible := True;
end;

procedure TForm1.Start1Click(Sender: TObject);
begin
  FileListBox1.ItemIndex := 0;
  I := 0;
  Start1.Enabled := False;
  Stop1.Enabled := True;
  Pause1.Enabled := True;
  Timer1.Enabled := True;
end;

procedure TForm1.N1Second1Click(Sender: TObject);
begin
  Timer1.Interval := 1000;
end;

procedure TForm1.N2Seconds1Click(Sender: TObject);
begin
  Timer1.Interval := 2000;
end;

procedure TForm1.N3Seconds1Click(Sender: TObject);
begin
  Timer1.Interval := 3000;
end;

procedure TForm1.N4Seconds1Click(Sender: TObject);
begin
  Timer1.Interval := 4000;
end;

procedure TForm1.Fast1Click(Sender: TObject);
begin
  Timer1.Interval := 50;
end;

procedure TForm1.Stop1Click(Sender: TObject);
begin
  Directory1.Enabled := True;
  Start1.Enabled := True;
  Stop1.Enabled := False;
  Pause1.Enabled := False;
  Timer1.Enabled := False;
end;

procedure TForm1.Stretch1Click(Sender: TObject);
begin
  Image1.Stretch := not Image1.Stretch;
end;

procedure TForm1.Panel1Exit(Sender: TObject);
begin
  FileListBox1.ItemIndex := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  I := 0;
  Units.x := 1;
  Units.y := 1;
  ScrollReset;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  I := FileListBox1.ItemIndex;
end;

procedure TForm1.Pause1Click(Sender: TObject);
begin
  Timer1.Enabled := not Timer1.Enabled;
  N1.Enabled := not N1.Enabled;
  N2.Enabled := not N2.Enabled;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  I := I - 1;
  N1.Enabled := True;
  FileListBox1.ItemIndex := FileListBox1.ItemIndex - 1;
  Image1.Picture.LoadFromFile(FileListBox1.FileName);
  ScrollReset;
  Caption := ExtractFileName(FileListBox1.FileName);
  if I = 0 then
   N2.Enabled := False;
   Label1.Caption := 'Current File No# ' + IntToStr(I) + '   ';
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  I := I + 1;
  N2.Enabled := True;
  FileListBox1.ItemIndex := FileListBox1.ItemIndex + 1;
  Image1.Picture.LoadFromFile(FileListBox1.FileName);
  ScrollReset;
  Caption := ExtractFileName(FileListBox1.FileName);
  if I = FileListBox1.Items.Count then
  N1.Enabled := False;
  Label1.Caption := 'Current File No# ' + IntToStr(I) + '   ';
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Dirty := True;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  if Sender as TScrollBar = ScrollBar2 then
    Image1.Top := -Units.y * ScrollBar2.Position;
end;

procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if ScrollBar1.Max <= 65535 then
    Image1.Left := -Units.x * ScrollPos
  else
    ShowMessage('Scrollbar ranges > 65535 not supported');
end;

procedure TForm1.Image1Progress(Sender: TObject; Stage: TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
  const Msg: String);
begin
  ScrollAdjust(True);
end;

procedure TForm1.ScrollAdjust(update: Boolean);
begin
  if Image1.Picture <> nil then
  begin
    ScrollBar1.Max := maxval(0, scale(Image1.Width - ImgPanel.Width, Units.x));
    ScrollBar2.Max := maxval(0, scale(Image1.Height - ImgPanel.Height, Units.y));
  end;
  if Update then
    UpdateDisplay;
end;

procedure TForm1.ScrollReset;
begin
  Units.x := DEF_SCROLL_UNITS;
  Units.y := DEF_SCROLL_UNITS;

  if Image1.Picture <> nil then
  begin
    Image1.Top := 0;
    Image1.Left := 0;
    ScrollBar1.Position := 0;
    ScrollBar2.Position := 0;

    ScrollBar1.Min := 0;
    ScrollBar2.Min := 0;
    ScrollAdjust(False);

    ScrollBar1.LargeChange := scale(ScrollBar1.Max, Units.x);
    ScrollBar2.LargeChange := scale(ScrollBar2.Max, Units.y);

    ScrollBar1.Visible := True;
    ScrollBar2.Visible := True;
  end;

  UpdateDisplay;
end;
procedure TForm1.UpdateDisplay;
begin
  Dirty := False;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Form2.Image1.Picture := Image1.Picture;
  Form2.Show;
end;

end.

